package com.bizmatics.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.bizmatics.common.core.util.DateUtils;
import com.bizmatics.model.HadDataLog;
import com.bizmatics.persistence.mapper.HadDataLogMapper;
import com.bizmatics.service.HadDataLogService;
import com.bizmatics.common.mvc.base.AbstractCrudService;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author ya
 * @since 2021-07-18
 */
@Service
public class HadDataLogServiceImpl extends AbstractCrudService<HadDataLogMapper, HadDataLog> implements HadDataLogService {

    @Override
    public List<HadDataLog> list(Date startTime, Date endTime) {
        LambdaQueryWrapper<HadDataLog> queryWrapper = Wrappers.lambdaQuery();
        queryWrapper.between(HadDataLog::getDataTime,startTime,endTime);
        return this.list(queryWrapper);
    }
}
